%% Lezione 10 Lab: Hidden Markov Model
% 

clear all
close all
clc

addpath(genpath('./HMM/'));

%% Esercizio 1

p = [0.5 0.1 0.4];
A = [0.8 0 0.2; 0.4 0.5 0.1; 0 0.3 0.7];
B = [0.95 0.05; 0.3 0.7; 0.1 0.9];

stati(1) = extract_disc_state(p);
oss(1) = extract_disc_state(B(stati(1),:));

for t = 2:1000
    
    stati(t) = extract_disc_state(A(stati(t-1),:));
    oss(t) = extract_disc_state(B(stati(t),:));
    
end

subplot(2,1,1), plot(stati(1:30))
subplot(2,1,2), plot(oss(1:30))

%% Esercizio 2

Q = 3; % numero di stati
O = 2; % numero di simboli

p1 = normalise(rand(Q,1));
A1 = mk_stochastic(rand(Q,Q));
B1 = mk_stochastic(rand(Q,O));

[LL, p1, A1, B1] = dhmm_em(oss, p1, A1, B1, 'max_iter', 10);

%% Esercizio 3
A2 = [0.6 0.1 0.3; 0.4 0.3 0.3; 0.2 0 0.8];
B2 = [0.7 0.3; 0.2 0.8; 0 1];
p2 = [0.5 0.1 0.4];

loglik1 = dhmm_logprob(oss, p1, A1, B1)
loglik2 = dhmm_logprob(oss, p2, A2, B2)

% E' più probabile che l'osservazione oss sia stata generata dal primo
% modello (la log-likelihood è più alta: loglik1 > loglik2)

%% Esercizio 4

obslik1 = mk_dhmm_obs_lik(oss, B1);
path = viterbi_path(p1, A1, obslik1);

